=== debian/changelog ===
clblas (2.8-1) unstable; urgency=medium

  * New upstream release.
  * d/patches:
    - Remove fix-missing-stdlib.patch, applied upstream.
    - Remove debian-enable-multiarch.patch, no longer needed.
    - Refresh disable-multilib-cflags.patch, fix-pthread-linkage.patch
      and use-boost-dynamic-libs.patch.
  * d/rules:
    - use SUFFIX_LIB cmake build option to enable multiarch.
    - add missing call to dh_doxygen.
  * Make build of documentation architecture independent:
    - Move doxygen dependency to Build-Depends-Indep,
    - Move call to doxygen to dh_auto_build-indep,
    - Clear doxygen artefacts in dh_auto_clean-indep.
  * Remove system jquery symlinks in HTML documentation:
    - Remove the install dependency on libjs-query,
    - Remove the .links file for the -doc package.
  * Run `cme fix` on d/control and d/changelog.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 27 Oct 2015 08:10:56 +0000

clblas (2.6-3) unstable; urgency=medium

  * d/rules: fix FTBFS on ppc64el. (Closes: #798024)
  * d/{control,rules}: now follows debmake layout.
  * add README.Debian, explains packaging policy and layout.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 19 Sep 2015 10:30:54 +0100
