=== debian/control ===
Source: clblas
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clblas.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/clblas.git
Homepage: https://github.com/clMathLibraries/clBLAS

Package: libclblas-bin
Architecture: any
Multi-Arch: foreign
Depends: libclblas2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: OpenCL BLAS library (executables)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS executables.

Package: libclblas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libclblas2 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libclblas-doc
Description: OpenCL BLAS library (development files)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS development files.

Package: libclblas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends}
Description: OpenCL BLAS library (documentation)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS documentation.

Package: libclblas2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL BLAS library (shared library)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS shared library.

Package: libclblas2-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: libclblas2 (= ${binary:Version}),
         ${misc:Depends}
Description: OpenCL BLAS library (debugging symbols)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS debugging symbols.
