## clblas 2.8+ds1

=== debian/changelog ===
clblas (2.8+ds1-1) unstable; urgency=medium

  * Add non-dfsg repack suffix.
    Reason: trigger a new source tarball upload of v2.8.
  * d/copyright: update year.
  * d/watch: add dversionmangling due to repack.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 28 Oct 2015 19:27:03 +0000

clblas (2.8-2) unstable; urgency=medium

  * Revert involuntary patching of source tree.
  * Fix FTBFS due to missing dependency on Python.
  * d/p: add add-missing-stdlib-include.patch, fixes FTBFS error due to
     missing inclusion of stdlib. 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 28 Oct 2015 15:44:38 +0000
