=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
 Build-Depends: cmake,
                debhelper (>= 9),
                libboost-program-options-dev,
-               ocl-icd-opencl-dev | opencl-dev
+               ocl-icd-opencl-dev | opencl-dev,
+               python
 Build-Depends-Indep: doxygen
 Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clblas.git
