=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Environment information.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Build without Altivec to prevent FTBFS on ppc64el.
ifeq ($(DEB_HOST_ARCH),ppc64el)
DEB_CFLAGS_MAINT_APPEND += -mno-altivec
endif

%:
	dh $@ --parallel \
		--sourcedirectory=src \
		--dbg-package=libclblas2-dbg

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_RUNTIME=ON \
		-DBUILD_TEST=OFF \
		-DBUILD_PERFORMANCE=OFF \
		-DBUILD_SAMPLE=OFF \
		-DBUILD_CLIENT=ON \
		-DBUILD_KTEST=OFF \
		-DBUILD_SHARED_LIBS=ON \
		-DSUFFIX_LIB=/${DEB_HOST_MULTIARCH}

override_dh_auto_build-indep:
	cd doc && doxygen clBLAS.doxy

override_dh_auto_install-indep:
	# Pass.

override_dh_auto_clean-indep:
	rm -rf doc/html
	rm -f doc/doxygen_sqlite3.db

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep
